function half = getHalfvector(V)

t_i = V(:,1);
t_v = V(:,2);
p_i = V(:,3);
p_v = V(:,4);

n = size(V,1);
in = zeros(n,3);
out = zeros(n,3);

% compute in vector
in(:,3) = cos(t_i);
xy = sin(t_i);
in(:,1) = xy.*cos(p_i);
in(:,2) = xy.*sin(p_i);
in = in./repmat(sqrt(sum(in.^2,2)),1,3);

% compute out vector
out(:,3) = cos(t_v);
xy = sin(t_v);
out(:,1) = xy.*cos(p_v);
out(:,2) = xy.*sin(p_v);
out = out./repmat(sqrt(sum(out.^2,2)),1,3);

% compute halfway vector
half = (in+out)/2.0;
half = half./repmat(sqrt(sum(half.^2,2)),1,3);


